/**
 * aliohjelmia (yht 26 kpl) mm. seuraaviin tehtviin:
 * - muunnoksiin
 * - tiedon lukemiseen
 * - arpomiseen
 * - tiedostonksittelyyn
 * - yleisi
 * 
 * Tehty: 7.2.2000, Pekka Kosonen
 * Muokattu: 22.7.2001, Pekka Kosonen
 *  - jrkeistetty ja listty funktioita 
 * 
 */

import java.io.*;
import java.util.*;
//import java.lang.*;
					 

public class Aliohj
{
	/** liukulukujen yhtsuuruusvertailussa kytettv vakio */
	
	private static final double EPSILON = 1E-10;

/*****************YLEISET*********************/	

	/**  Tutkii,onko osa-mjono osa mista-mjonoa */
		public static int onkoOsa( String osa, String mista, boolean caseSensitive )
		  throws StringIndexOutOfBoundsException
	{
		/* Palauttaa:
		     -1   - ei ole osamerkkijono
		     muut - mista osamerkkijono alkaa
			
		   jos caseSensitive == false, niin isot ja pienet
		   kirjaimet samaistetaan.
		*/
		String pala = "";
		
		
		for( int i=0; i < ( mista.length() - osa.length() + 1); i++ )
		{
			if ( caseSensitive )
			{
				pala = mista.substring(i, i + osa.length() );
				if( pala.compareTo( osa ) == 0 )
					 return i;
				}
			else 
				if( (mista.substring(i, i + osa.length() ).toLowerCase().compareTo( osa.toLowerCase() ) == 0 ) )
					 return i;
				
		}
		return -1;
	}
	
	/** Odottaa sytttietoa ja sitten tyhjentaa puskurin
	 */
	public static void odotaJotakin()
	{
		try {
			System.in.read();
			tyhjenna( System.in );
		}
		catch ( IOException e )
		{
			System.out.println("Virhe odotaJotakin-funktiossa:");
			System.out.println( e.toString() );
		}
			
	}
	/** Tyhjentaa tuodun virran
	 */
	public static boolean tyhjenna( InputStream virta)
	{
		try {
		int montako = virta.available();
		virta.skip(montako);
		return true;
		}
		catch(  IOException e )
		{
			System.err.println("Virtaa " + virta + 
							 " ei saatu tyhjennetty.");
			return false;	  
			  
		}
	}
	
	/** Palauttaa 1 jos vastattiin kyll
	 */
	public static int kyllaVastaus()
	{
		//metodi lukee kyll vai ei, palauttaa: 
		//  1  jos  KYLLA 
		//  0  jos  EI
		//  2 jos  ENTER
		//  -1  jos  VIRHE (tieto ei muunnettavissa kyll/ei-muotoon)
		// kaikki sanat joiden eka kirjain on 1)k -> kylla 2) e -> ei .
		
		try
		{
			String vastaus = lueRivi();
			
			if( vastaus.length() == 0 )
				 return 2;
			
			if ( vastaus.charAt(0) == 'k' || vastaus.charAt(0) == 'K')
				return 1;
			
			if ( vastaus.charAt(0) == 'e' || vastaus.charAt(0) == 'E')
				return 0;
			
			return -1;
		}
		catch( IOException ioe )//poikkeukset kiinni
		{
			System.out.println("Virhe kyllaVastaus-funktiossa:\n");
			System.out.println(ioe.toString());//tulostetaan poikkeus
			ioe.printStackTrace();
			return -1;
		}
	}
	
  /**  Tulostetaan hopute ja luetaan ptteelt rivi, mikli pelkk RETURN palauttaa oletuksen 
   */
	public static String lueJonoOletus(String hopute, String oletus) throws IOException
	{
		/*	Luetaan ptteelt rivi. Mikli pelkk RET -> oletus.Hoputteeksi "hopute (oletus) >" */
		System.out.print(hopute + " (" + oletus + ") >");
		String jono = lueRivi();
		//jos ptteelt sytetty tyhj, palautetaan oletus
		if ( jono.compareTo( "" ) == 0 ) return oletus;
		
		return jono;
	}

	/** Muuntaa Stringin liukuluvuksi
	 */
	public static double StrToDouble(String s)
		throws NumberFormatException
	{
		return Double.valueOf ( s ).doubleValue();
	}
	
	
	/** Muuntaa Stringin kokonaisluvuksi
	 */
	public static int StrToInt(String s)
		throws NumberFormatException
	{
		return Integer.parseInt ( s );
	}
	
/*****************MUUNNOS*********************/	
	
	/** Yksi merkki Stringiksi
	 */
	public static String CharToStr(char kirjain)
	{
      StringBuffer sb= new StringBuffer();//stringbufferiksi
	  sb.append(kirjain);
	  return sb.toString();
	}
	
	/** Merkki kokonaisluvuksi
	 */
	
	public static int CharToInt(char kirjain)
	{
	  //Jos kirjain ei ole numero -> return 0;
	  String jono = CharToStr(kirjain);
	  return  StrToInt(jono);
	}
	
	/** Kokonaisluku Stringiksi
	 */
	public static String IntToStr(int nro)
	{
		//palauttaa tuodun intin string-muodossa.
		
		//return new StringBuffer(
		StringBuffer sb= new StringBuffer();
		sb.append(nro);
		return  sb.toString();
	}
	/** Palauttaa Stringin ensimmisen merkin
	 */
	public static char StrToChar(String s)
	{
		//Palauttaa stringin ekan kirjaimen char:ina
		return s.charAt(0);
	}
	
	/** Luetaan sytttieto ja muutetaan se kokonaisluvuksi
	 */
	public static int kysyInt(String kysymys)
		throws NumberFormatException, IOException
	{//palauttaa luetun rivin kokonaislukuna
		// Luodaan puskuroitu lukuvirta BufferedReader
		BufferedReader in = new BufferedReader 
			( new InputStreamReader(System.in) );
			
		System.out.print(kysymys);
		String apu = in.readLine();
		return StrToInt( apu );
	}

/*****************KYSYMISET*********************/		
	
	/** Luetaan sytttieto ja muutetaan se liukuluvuksi
	 */
	public static double kysyDouble(String kysymys)
		throws NumberFormatException, IOException
	{//palauttaa luetun rivin kokonaislukuna
		// Luodaan puskuroitu lukuvirta BufferedReader
		BufferedReader in = new BufferedReader 
			( new InputStreamReader(System.in) );
			
		System.out.print(kysymys);
		String apu = in.readLine();
		return StrToDouble( apu );
	}

	/** Luetaan sytttieto ja palautetaan se Stringin
	 */
	public static String lueRivi()
		throws IOException
	{//palauttaa luetun rivin 
		// Luodaan puskuroitu lukuvirta BufferedReader
		BufferedReader in = new BufferedReader 
			( new InputStreamReader(System.in) );
			
		//System.out.print(kysymys);
		String apu = in.readLine();
		return apu;
	}

	/** Luetaan sytttieto ja palautetaan se, ensin tulostetaan parametrin arvo
	 */
	public static String lueRivi( String jono)
		throws IOException
	{//palauttaa luetun rivin, tulostaa ensin tekstin
		System.out.print(jono);
		return lueRivi() ;
	}

/*****************ARPOMISET*********************/		
	/** Arpoo satunnaisen kokonaisluvun
	 */
	public static int randomInt( int alaraja, int ylaraja)
	{  //arpoo kokonaisluvun vlill alaraja - ylaraja
		//
		
		return  (int) randomDouble( alaraja, ylaraja)  ;
	}
	
  /** Arpoo satunnaisen liukuluvun
   */
	public static double randomDouble( double alaraja, double ylaraja)
	{  //arpoo liukuluvun vlill alaraja - ylaraja
		//
		if ( alaraja >= ylaraja ) //jos rajat vrin
			  throw new IllegalArgumentException();
		return  alaraja + (ylaraja - alaraja) * Math.random() ;
	}

/*****************VERTAILU*********************/		

	/** Vertaa kahta liukulukua, jos ne ovat EPSILON:in pss toisistaan
	 *  niin palauttaa 0
	 */
	public static int samatLuvut( double a, double b)
	{
		//vertaa kahta liukulukua ovatko ne epsilonin pss toisistaan.
		//palauttaa:
		// 0 - samat
		// 1 - a suurempi
		// 2 - b suurempi
		
		double vertailu = (a - b) / ( 1 + Math.max( Math.abs(a), Math.abs(b) ) );
	    if  ( vertailu < -EPSILON ) return -1;
		if  ( vertailu > EPSILON ) return 1;
	    return 0;
	}

	/** Vertaa trimmattua Stringia ja kokonaislukua toisiinsa ja palauttaa true jos samat.
	 */
	public static boolean onkoSamat(String s, int n)//static koska luokkametodi(*1)
	{
		//Vertaa String ja int,palauttaa true jos samat
		if ( s.trim().compareTo( IntToStr(n) ) == 0) return true;
		return false;
	}
	
	
/*****************TDSTO***************************/
	
	public static int tiedKopi(String mista, String mihin)
	{/* kopioi ekana parametrina tuodun tiedoston toiseen parametritiedostoon */
		/*	TO DO: virheksittely paremmaksi	*/
		
		File sisaanTied;
		File ulosTied;
		FileInputStream sisaan;
		FileOutputStream ulos;
		
		try	{
			int num;
			sisaanTied = new File(mista);//mista-tiedosto PIT olla olemassa,muuten virhe
			ulosTied = new File(mihin);//mihin-tied. ei vli onko olemassa, luodaan
			sisaan = new FileInputStream(sisaanTied);
			ulos = new FileOutputStream(ulosTied);
			while ((num = sisaan.read()) != -1)
				ulos.write(num);
			sisaan.close();
			ulos.close();
			return 0;//OK
		}
		
		catch (FileNotFoundException E)
		{
			System.out.println("virhe aliohjelmassa tiedKopi:");
			System.out.println("Ei lydy tiedostoa " + mista);
			return 1;
		}
		
		catch (IOException E)
		{
			System.out.println("virhe aliohjelmassa tiedKopi:");
			System.out.println(E);
			return 2;
		}
		
	}
	
  public static int kirjoitaRivi(String tiedosto, String rivi, boolean tyhjennetaanko)
	{
		/*  kirjoittaa rivin tiedoston loppuun jos tyhjennetaanko on false.
			muuten tyhjent tiedoston ja kirjoittaa sen alkuun. */
		/*  Haluttaessa kirjoittaa tiedoston loppuun, 
		niin luetaan tdsto Stringiin ja listn siihen rivi. */
		
		try {
			String tdston_sis="";
			if ( tyhjennetaanko == false )//eli halutaan kirjoittaa tdston loppuun
			{
				tdston_sis = lueTdsto(tiedosto);//lukee tiedoston Stringiin,rivinvaihto '/n' .
				tdston_sis = tdston_sis;
			}
			FileOutputStream fos = new FileOutputStream(tiedosto);
			PrintWriter pr = new PrintWriter(fos);
		
			/*  Ongelmana on se, ettei tiedosto olisi monessa Streamissa yht aikaa auki! 
				Siksi jouduttu kahdesti tekemn if( tyhjennetnk ) !*/
			if ( tyhjennetaanko == false ) 
				pr.print(tdston_sis);	
			pr.println(rivi);
		
			pr.flush();//pit muistaa tyhjent puskuri
			pr.close();//ja sulkea
		}
		
		catch (IOException e) { System.out.println(e); odotaJotakin();}

		return 0;
	}

	public static String lueTdsto(String tdsto)
		  throws FileNotFoundException
	{
		/* Lukee tiedoston yhteen Stringiin, jonka se palauttaa. */
		//toivottavasti ei tule ongelmia suurissa tdstoissa.
		
		StringBuffer s = new StringBuffer("");
		
		String k="";
		
		int i=1;
		
		while ( k != null ) 
		{
			k = lueRiviTdsto(tdsto,i); //luetaan yksi rivi
		
			if ( k != null ) //jos ei tiedosto loppu
			{	
				s.append(k); //liitetn k s:n
				s.append('\n'); //lisataan rivinvaihto
			}
			i++;
		}
		
		k = s.toString();

		return k;
	}
	public static String lueRiviTdsto(String tiedosto, int rivinro)
		  throws FileNotFoundException
	{
		/* Lukee tiedostosta parametrina tuodun rivin,palauttaa sen Stringin
		   Ei laita rivinvaihtoa palautettavaan merkkijonoon */
		
		FileReader sis; //pit tehd ensin
		LineNumberReader sisaan;
		String s ="";
		
		try {
			int num;
			sis = new FileReader(tiedosto);
		
			sisaan = new LineNumberReader(sis);
		
			for(int i=0; i<rivinro;i++)
				s=sisaan.readLine();
		
			sis.close();
			sisaan.close();
			return s;
		}
		
/*		catch (FileNotFoundException E)
		{
			System.out.println("virhe aliohjelmassa lueRivi:");
			System.out.println("Ei lydy tiedostoa " + tiedosto);
			//System.out.println(E);
			return "";
		}
*/		
		catch (IOException E)
		{
			System.out.println("virhe aliohjelmassa lueRiviTdsto:");
			System.out.println(E);
			return "";
		}
	}

	public static String patki(String jono,char erotin,int monesko)
	{
		/*  Palauttaa jonosta erottimien vliss olevan jonon. Jos monesko liian suuri -> ""
		TO DO: muuta s.e. ei tartte olla erotinta ekana ja viimeisen.
		Voisi hoitaa Stringtokanizerilla.*/
		
		
		StringBuffer sb = new StringBuffer(jono);
		String paluu = "";
		StringBuffer taulu = new StringBuffer();
		int laskuri = 0;
		
		if ( monesko <= 0 ) monesko = 1; //monesko pakko olla positiivinen
		
		//kirjoitetaan erotinmerkkien vliss olevat kirjaimet tauluun
		for(int i=0; i<(sb.length()-1); i++)
		{
			if( sb.charAt(i)==erotin ) //eli jos erotin lytynyt
				laskuri++;             //niin kasvatetaan laskuria
			
			if( (monesko)==laskuri )    //jos lydetty oikea vli
			{
				i++; //siirrytn ekaan erottimen jlkeiseen kirjaimeen
				//silmukka joka laittaa charit tauluun
				while ( sb.charAt(i)!= erotin && i < sb.length()-1 ) //pit tutkia erikseen
				{
					taulu.append( sb.charAt(i) ); //tytetn taulua kirjaimilla
					i++;
				}
			break;
			}
		}
		return taulu.toString();
	}
	
	/*  SYSTEEMITIETOJA */
	

/** Palauttaa tietoa kyttjrjestelmst
 */
public static String OSInfo()
{												 
/*
	os.name			Operating system name 
	os.arch			Operating system architecture
	os.version	Operating system version	*/
	return "OS: " + System.getProperty( "os.name" ) 
				 + " VERSION: "  + System.getProperty( "os.version" ) ;
	
}	

/** Palauttaa tietoa kyttjst
 */
public static String userInfo()
{												 
/*
user.name	User's account name
user.home	User's home directory
user.dir	User's current working directory
*/
return "USER: " + System.getProperty( "user.name" ) 
				 + " HOME: "  + System.getProperty( "user.home" ) 
			   + " CWD: " + System.getProperty( "user.dir" );	
}


/****************** AIKA *********/

/** Palauttaa kuluvan vuoden
 */
public static int vuosi()
{
	GregorianCalendar kal = new GregorianCalendar();
	//Date aika = kal.getTime();
	return kal.getTime().getYear() + 1900;
}

/** Palauttaa paikallisen ajan muodossa pp-kk-vv hh:mm:ss
 */
public static String aika()
{
	GregorianCalendar kal = new GregorianCalendar();
	//Date aika = kal.getTime();
	return kal.getTime().toLocaleString();
}

/*****************MAIN***************************
 	
	public static void main (String[] args)
	{
		//********TESTAUSTA*****************
		/*
		try {
		boolean kumpi = OnkoSamat("0", 0);
		int nro=CharToInt('4');
		//nro=StrToInt("343434");
		String jono=CharToStr('w');
		//kumpi=true;
		//kysyInt();
		//int k=StrToInt("1345");
		//k=k;
		char s=StrToChar("kakka");
		
		kysyInt("Anna:");
		}
		catch ( IOException ioe )
		{
			System.out.print ( ioe.toString() );
		}
		catch ( Exception ioe )
		{
			ioe.printStackTrace();
		}
		finally
		{
			//System.in.read();
		}
		
		*/
		/*
		String jono = IntToStr(5);
		boolean onko = onkoSamat(" 5 ",5);
		onko = false;
		*/
		/*
		double arvottu = randomDouble( 0.4, 100.1);
		int arvottu2 = randomInt( 20,25);
		
		System.out.print( arvottu + ", " + arvottu2);
		*/
		/*
		int luku = samatLuvut(30.00000000000002, 30.00000000000003);
		switch ( luku ) {
			case -1 : System.out.print ("Eka argumentti pienempi");
			case 0 : System.out.print ("Samat luvut");
			case 1 : System.out.print ("Toka argumentti pienempi");
		};	
		*/
		
		//String jono = "";
		//jono.
		//patki( jono, '*', 2);
	
		/*
		String filee = "";
		
		try {
			filee = "C:\\temp\\jorma.txt";
			System.out.print( lueTdsto(filee) );
			odotaJotakin();
		}
		catch ( FileNotFoundException e )
		{
			System.out.println("Tiedostoa "	 + filee +
				"Ei saada avattua.");								 
		}
		*/
		
		//kirjoita
		/*
		System.out.println( onkoOsa("kissa","Kissa", false ) );
		odotaJotakin();
		*/
		/*
		//System.out.println( OSInfo() );
		//System.out.println( userInfo() );
		//kirjoitaRivi("CWD.txt","MORJENS", true);
		
		//setCWD("c:\\temp\\");
		//System.out.println( userInfo() );
		//kirjoitaRivi("CWD.txt","MORJENS2", true);
		
		
		//System.out.println( userInfo() );
		//odotaJotakin();
	}

		*/
}

