import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.*;

public class initPara extends HttpServlet {
  private static final String CONTENT_TYPE = "text/html";
  //attribuutit
  private int luvut[];
  private int koko;
  private String otsikko;
  private boolean ok;


  public void init() throws ServletException {
    //luetaan alustusparametrit, asetettu web.xml tiedostossa
    otsikko = this.getServletConfig().getInitParameter("otsikko");
    String k = this.getServletConfig().getInitParameter("koko");

// tai nin:
//  ServletConfig asetukset = getServletConfig();
//  otsikko = asetukset.getInitParameter("otsikko");
//  String k = asetukset.getInitParameter("koko");

    if( otsikko == null || k == null ) //testataan onnistuiko luku
    {
      ok = false;
      return;
    }
    else
      ok = true;

    try {
    koko = Integer.parseInt( k );
    }
    catch (NumberFormatException e )
    { //voisi tehd jotain jrkevmpkin
      ok = false;
      otsikko = "WebApplication tutoriaali - koko oltava kokonaisluku!";
      return;
    }

    luvut = new int[koko]; //luodaan annetun kokoinen taulukko

    for( int i=0; i < koko; i++ )
      luvut[i] = (int) Math.round( 1 / Math.random() ); //1 / (arvo vlill 0 - 1)
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    response.setContentType(CONTENT_TYPE);
    PrintWriter out = response.getWriter();
    out.println("<html>");

    out.println("<head><title>" + otsikko + "</title></head>");
    out.println("<body>");

    if ( !ok )
    {
      out.println("<H1>Alustusparameteja ei saatu luettua oikein. Tarkista web.xml tiedosto</H1>");
      out.println("</body></html>");
      return;
    }

    out.println("<H3 align=\"center\">Arvotut luvut</H3>");

    out.println("<HR> <BR> <BR>");

    for( int i=0; i < koko; i++ )
      out.println( luvut[i] + "<BR>");

    out.println("</body></html>");
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    doGet(request, response); //kutsutaan doGet-metodia
  }

  /**Clean up resources*/
  public void destroy() {
    luvut = null; //ei pakollista
  }

 /* Esimerkkej erilaisista tavoista lukea init parametrit
   // This method is called by the servlet container just before this servlet
    // is put into service.
    public void init() throws ServletException {
        ok = true;
        otsikko = "Alustettu";

        //getServletContext().log("getinit init");
        // Get the value of an initialization parameter
        //String value = getServletConfig().getInitParameter("param1");

        // Get all available intialization parameters
        java.util.Enumeration enum = getServletConfig().getInitParameterNames();
        for (; enum.hasMoreElements(); ) {
            otsikko = "Oli param";
            // Get the name of the init parameter
            String name = (String)enum.nextElement();
            if( name != null )
              otsikko.concat(name);

            otsikko.concat(":");
            // Get the value of the init parameter
            String value = getServletConfig().getInitParameter(name);
            if( value != null )
              otsikko.concat(value);
            otsikko.concat("<BR>");
        }

        // The int parameters can also be retrieved using the servlet context
        //value = getServletContext().getInitParameter("param1");
    }
*/

}


